eslint-plugin-compat
Lint browser compatibility of API used
Last updated 16 days ago by jtran .
MIT · Repository · Bugs · Original npm · Tarball · package.json
$ cnpm install eslint-plugin-compat 
SYNC missed versions from official npm registry.

eslint-plugin-compat

Build Status Financial Contributors on Open Collective NPM version Dependency Status npm Backers on Open Collective Sponsors on Open Collective

Lint the browser compatibility of your code

demo of plugin usage

Setup

1. Install

npm install --save-dev eslint-plugin-compat

2. Update ESLint Config

.eslintrc.json

   {
+    "extends": ["plugin:compat/recommended"],
+    "env": {
+      "browser": true
+    },
     // ...
   }

3. Configure Target Browsers

Browser targets are configured using browserslist. You can configure browser targets in your package.json:

package.json

   {
     // ...
+    "browserslist": [
+      "defaults"
+    ]
  }

If no configuration is found, browserslist defaults to "> 0.5%, last 2 versions, Firefox ESR, not dead".

See browserslist/browserslist for more details.

Adding Polyfills

Add polyfills to the settings section of your eslint config. Append the name of the object and the property if one exists. Here are some examples:

{
  // ...
  "settings": {
    "polyfills": [
      // Example of marking entire API and all methods and properties as polyfilled
      "Promise",
      // Example of marking specific method of an API as polyfilled
      "WebAssembly.compile",
      // Example of API with no property (i.e. a function)
      "fetch",
      // Example of instance method, must add `.prototype.`
      "Array.prototype.push"
    ]
  }
}

Demo

For a minimal demo, see amilajack/eslint-plugin-compat-demo

Advanced

Road Map

See the Road Map for the details.

Inspiration

Toolchains for native platforms, like iOS and Android, have had API linting from the start. It's about time that the web had similar tooling.

This project was inspired by a two hour conversation I had with someone on the experience of web development and if it is terrible or not. The premise they argued was that x browser doesn't support y feature while z browser does. Eventually, I agreed with him on this and checked made this plugin to save web developers from having to memorize browser compatibility of specs.

Related

Contributors

Code Contributors

This project exists thanks to all the people who contribute. [Contribute].

Financial Contributors

Become a financial contributor and help us sustain our community. [Contribute]

Individuals

Organizations

Support this project with your organization. Your logo will show up here with a link to your website. [Contribute]

Current Tags

  • 3.8.0                                ...           latest (16 days ago)
  • 3.8.0-2                                ...           next (16 days ago)

69 Versions

  • 3.8.0                                ...           16 days ago
  • 3.8.0-2                                ...           16 days ago
  • 3.8.0-1                                ...           a month ago
  • 3.8.0-0                                ...           a month ago
  • 3.7.0                                ...           2 months ago
  • 3.7.0-1                                ...           2 months ago
  • 3.7.0-0                                ...           2 months ago
  • 3.6.0                                ...           2 months ago
  • 3.6.0-0                                ...           3 months ago
  • 3.5.1                                ...           6 months ago
  • 3.5.1-0                                ...           6 months ago
  • 3.5.0-0                                ...           6 months ago
  • 3.4.1-0                                ...           7 months ago
  • 3.4.0-0                                ...           7 months ago
  • 3.3.0                                ...           a year ago
  • 3.3.0-1                                ...           a year ago
  • 3.3.0-0                                ...           a year ago
  • 3.2.0                                ...           a year ago
  • 3.1.2                                ...           a year ago
  • 3.1.1                                ...           a year ago
  • 3.1.0                                ...           a year ago
  • 3.1.0-0                                ...           a year ago
  • 3.0.2-0                                ...           a year ago
  • 3.0.1                                ...           a year ago
  • 3.0.1-1                                ...           a year ago
  • 3.0.1-0                                ...           a year ago
  • 3.0.0                                ...           a year ago
  • 3.0.0-1                                ...           a year ago
  • 3.0.0-0                                ...           a year ago
  • 2.7.0                                ...           a year ago
  • 2.6.3                                ...           2 years ago
  • 2.6.2                                ...           2 years ago
  • 2.6.1                                ...           2 years ago
  • 2.6.0                                ...           2 years ago
  • 2.6.0-1                                ...           2 years ago
  • 2.6.0-0                                ...           2 years ago
  • 2.5.1 [deprecated]           ...           2 years ago
  • 2.5.0                                ...           2 years ago
  • 2.4.0                                ...           2 years ago
  • 2.3.0                                ...           2 years ago
  • 2.3.0-0                                ...           2 years ago
  • 2.2.1-0                                ...           2 years ago
  • 2.2.0                                ...           2 years ago
  • 2.1.0                                ...           3 years ago
  • 2.0.1                                ...           3 years ago
  • 2.0.0                                ...           3 years ago
  • 1.0.4                                ...           3 years ago
  • 1.0.3                                ...           3 years ago
  • 1.0.2                                ...           3 years ago
  • 1.0.2-1                                ...           3 years ago
  • 1.0.2-0                                ...           3 years ago
  • 1.0.1                                ...           3 years ago
  • 1.0.0                                ...           4 years ago
  • 1.0.0-2                                ...           4 years ago
  • 1.0.0-1                                ...           4 years ago
  • 1.0.0-0                                ...           4 years ago
  • 0.1.3                                ...           4 years ago
  • 0.1.2                                ...           4 years ago
  • 0.1.1                                ...           4 years ago
  • 0.1.0                                ...           4 years ago
  • 0.0.8-0                                ...           4 years ago
  • 0.0.7                                ...           4 years ago
  • 0.0.6                                ...           4 years ago
  • 0.0.5                                ...           4 years ago
  • 0.0.4                                ...           4 years ago
  • 0.0.4-0                                ...           4 years ago
  • 0.0.3-0                                ...           4 years ago
  • 0.0.2-0                                ...           4 years ago
  • 0.0.1                                ...           4 years ago
Maintainers (1)
Downloads
Today 74
This Week 2,915
This Month 29,816
Last Day 2,841
Last Week 16,309
Last Month 66,801
Dependencies (8)
Dev Dependencies (26)
Dependents (264)

Copyright 2014 - 2016 © taobao.org |